---
title: List Exclusion Groups
slug: feature-experimentation/api/list-exclusion-groups
docTags: 
createdAt: 2026-08-28T15:54:06.731Z
---

{
  "id": "g-nBQm7DdgTREbMGv08s7",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "https://api.optimizely.com/flags/v1//projects/{project_id}/groups",
    "servers": [
      {
        "url": "https://api.optimizely.com/flags/v1//projects/{project_id}/groups"
      }
    ],
    "name": "List Exclusion Groups",
    "description": "<p>Get a list of exclusion groups within a project</p>\n<p>You can use query parameters to filter/sort the response.</p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "project_id",
          "type": "integer",
          "example": 12345,
          "description": "The project identifier"
        }
      ],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "per_page",
          "type": "integer<int64>",
          "description": "The max number of items to include per page or results.",
          "format": "int64"
        },
        {
          "kind": "optional",
          "name": "page_token",
          "type": "string",
          "description": "<p>Pagination page token. Implements prev, next, last, first</p>"
        },
        {
          "kind": "optional",
          "name": "page_window",
          "type": "integer",
          "description": "<p>Number of previous and next page links to supply for the request (defaults to 1).</p>"
        },
        {
          "kind": "optional",
          "name": "sort",
          "type": "array",
          "description": "Sort the Groups based on the attributes from left to right.\n",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "archived",
          "type": "boolean",
          "description": "<p>Filter the Groups by archived. A Group can be either archived (archived=true) or unarchived (archived=false)</p>"
        },
        {
          "kind": "optional",
          "name": "enabled",
          "type": "boolean",
          "description": "<p>Filter the Groups by enabled. A Group can be either enabled (enabled=true) or disabled (enabled=false)</p>"
        },
        {
          "kind": "optional",
          "name": "environment",
          "type": "array",
          "description": "Filter the Groups by the environment\n",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "query",
          "type": "string",
          "description": "Filter the Groups by name or\ndescription substring\n"
        },
        {
          "kind": "optional",
          "name": "include",
          "type": "array",
          "description": "Ensure that the group id listed is returned first\n",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        }
      ],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "apiKey",
          "name": "apiKey",
          "kind": "optional",
          "type": "http",
          "scheme": "bearer"
        },
        {
          "id": "OAuth2",
          "name": "OAuth2",
          "kind": "optional",
          "type": "oauth2",
          "description": "Write applications that authenticate with the REST API via OAuth 2.0.",
          "oauth2Flows": {
            "authorizationCode": {
              "authorizationUrl": "https://app.optimizely.com/oauth2/authorize",
              "tokenUrl": "https://app.optimizely.com/oauth2/token",
              "scopes": {
                "all": "Grants all access"
              }
            }
          },
          "requiredScopes": [
            "read",
            "write"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "<p>Successful retrieval of a page of Groups.</p>\n<p>The response includes RESTful JSON (<a href=\"https://restfuljson.org/\" target=\"_blank\">https://restfuljson.org/</a>) styled links and pagination metadata.\nObjects in this API MAY include a url property for a link to itself and MAY append _url to properties for related links.\nIf a link is not present in the response, it indicates a user is not authorized to access the related resource.</p>",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "Groups",
            "schema": [
              {
                "name": "count",
                "kind": "required",
                "type": "integer",
                "description": "Number of Groups on the current page.",
                "example": 2
              },
              {
                "name": "create_url",
                "kind": "optional",
                "type": "object",
                "description": "",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlValue",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlValue",
                    "schema": []
                  }
                ],
                "schema": []
              },
              {
                "name": "filter_url",
                "kind": "optional",
                "type": "object",
                "description": "<p>Url template like '.../{?filter}'</p>",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlValue",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlValue",
                    "schema": []
                  }
                ],
                "schema": []
              },
              {
                "name": "first_url",
                "kind": "required",
                "type": "object",
                "description": "Link to first page of Groups in a series.",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlValue",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlValue",
                    "schema": []
                  }
                ],
                "schema": []
              },
              {
                "name": "items",
                "kind": "required",
                "type": "array",
                "description": "",
                "modelRef": "#/components/schemas/Group",
                "customType": "Group[]",
                "schema": [
                  {
                    "name": "archive_url",
                    "kind": "optional",
                    "type": "object",
                    "readOnly": true,
                    "description": "",
                    "complexType": "allOf",
                    "complexItems": [
                      {
                        "name": "UrlValue",
                        "description": "",
                        "modelRef": "#/components/schemas/UrlValue",
                        "schema": []
                      }
                    ],
                    "schema": []
                  },
                  {
                    "name": "archived",
                    "kind": "optional",
                    "type": "boolean",
                    "description": "",
                    "example": false
                  },
                  {
                    "name": "created_time",
                    "kind": "required",
                    "type": "string<date-time>",
                    "readOnly": true,
                    "description": "",
                    "example": "2019-05-08T00:00:00.000Z",
                    "format": "date-time"
                  },
                  {
                    "name": "delete_url",
                    "kind": "optional",
                    "type": "object",
                    "readOnly": true,
                    "description": "",
                    "complexType": "allOf",
                    "complexItems": [
                      {
                        "name": "UrlValue",
                        "description": "",
                        "modelRef": "#/components/schemas/UrlValue",
                        "schema": []
                      }
                    ],
                    "schema": []
                  },
                  {
                    "name": "description",
                    "kind": "optional",
                    "type": "string",
                    "description": "",
                    "example": "promotion group"
                  },
                  {
                    "name": "environment_key",
                    "kind": "required",
                    "type": "string",
                    "description": "",
                    "example": "production",
                    "minLength": 1
                  },
                  {
                    "name": "id",
                    "kind": "required",
                    "type": "integer",
                    "readOnly": true,
                    "description": "",
                    "example": 1
                  },
                  {
                    "name": "name",
                    "kind": "required",
                    "type": "string",
                    "description": "",
                    "example": "PromoGroup"
                  },
                  {
                    "name": "project_id",
                    "kind": "optional",
                    "type": "integer<int64>",
                    "description": "The ID of the Project this Group belongs to",
                    "format": "int64"
                  },
                  {
                    "name": "revision",
                    "kind": "optional",
                    "type": "integer",
                    "readOnly": true,
                    "description": "Revision number for tracking changes"
                  },
                  {
                    "name": "role",
                    "kind": "optional",
                    "type": "string",
                    "readOnly": true,
                    "description": "Granular permission role",
                    "example": "admin"
                  },
                  {
                    "name": "rules",
                    "kind": "optional",
                    "type": "object",
                    "description": "",
                    "complexType": "allOf",
                    "complexItems": [
                      {
                        "name": "GroupRuleMap",
                        "description": "",
                        "modelRef": "#/components/schemas/GroupRuleMap",
                        "schema": []
                      }
                    ],
                    "schema": []
                  },
                  {
                    "name": "unarchive_url",
                    "kind": "optional",
                    "type": "object",
                    "readOnly": true,
                    "description": "",
                    "complexType": "allOf",
                    "complexItems": [
                      {
                        "name": "UrlValue",
                        "description": "",
                        "modelRef": "#/components/schemas/UrlValue",
                        "schema": []
                      }
                    ],
                    "schema": []
                  },
                  {
                    "name": "update_url",
                    "kind": "optional",
                    "type": "object",
                    "readOnly": true,
                    "description": "",
                    "complexType": "allOf",
                    "complexItems": [
                      {
                        "name": "UrlValue",
                        "description": "",
                        "modelRef": "#/components/schemas/UrlValue",
                        "schema": []
                      }
                    ],
                    "schema": []
                  },
                  {
                    "name": "updated_time",
                    "kind": "required",
                    "type": "string<date-time>",
                    "readOnly": true,
                    "description": "",
                    "example": "2019-05-08T00:00:00.000Z",
                    "format": "date-time"
                  },
                  {
                    "name": "url",
                    "kind": "optional",
                    "type": "object",
                    "readOnly": true,
                    "description": "Link to self",
                    "complexType": "allOf",
                    "complexItems": [
                      {
                        "name": "UrlValue",
                        "description": "",
                        "modelRef": "#/components/schemas/UrlValue",
                        "schema": []
                      }
                    ],
                    "schema": []
                  },
                  {
                    "name": "urn",
                    "kind": "required",
                    "type": "string",
                    "readOnly": true,
                    "description": "The URN for the Group",
                    "example": "groups.flag.optimizely.com::1"
                  }
                ]
              },
              {
                "name": "last_url",
                "kind": "required",
                "type": "object",
                "description": "Link to the last page of Groups in a series.",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlValue",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlValue",
                    "schema": []
                  }
                ],
                "schema": []
              },
              {
                "name": "next_url",
                "kind": "optional",
                "type": "object",
                "description": "<p>List of links to next pages of Groups in a series.</p>\n<p>The first element in the array is the exact next page after the current record, etc.</p>",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlList",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlList",
                    "schema": []
                  }
                ],
                "schema": []
              },
              {
                "name": "page",
                "kind": "required",
                "type": "integer",
                "description": "<p>Number of the current page. 1-index based.</p>",
                "example": 5
              },
              {
                "name": "prev_url",
                "kind": "optional",
                "type": "object",
                "description": "<p>List of links to previous pages of Groups in a series.</p>\n<p>The first element in the array is the exact previous page before the current record, etc.</p>",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlList",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlList",
                    "schema": []
                  }
                ],
                "schema": []
              },
              {
                "name": "reset_url",
                "kind": "optional",
                "type": "object",
                "description": "Link to the default pages of Groups",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlValue",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlValue",
                    "schema": []
                  }
                ],
                "schema": []
              },
              {
                "name": "sort_url",
                "kind": "optional",
                "type": "object",
                "description": "<p>Url template like '.../{?sort}'</p>",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlValue",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlValue",
                    "schema": []
                  }
                ],
                "schema": []
              },
              {
                "name": "total_count",
                "kind": "required",
                "type": "integer",
                "description": "Total number of Groups for this series.",
                "example": 20
              },
              {
                "name": "total_pages",
                "kind": "required",
                "type": "integer",
                "description": "Total number of pages for this series.",
                "example": 10
              },
              {
                "name": "url",
                "kind": "required",
                "type": "object",
                "description": "Link to self",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "UrlValue",
                    "description": "",
                    "modelRef": "#/components/schemas/UrlValue",
                    "schema": []
                  }
                ],
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Groups",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "Malformed requests and invalid parameter names and types",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "401",
        "description": "Invalid credentials",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Do not have permission to perform the operation",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "icZIBPSIguSE6ulK_JmMl",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url https://api.optimizely.com/flags/v1//projects/{project_id}/groups \\\n     --header 'accept: application/json'"
        },
        {
          "id": "OVP4pYl3hkme6zVW79UAv",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.optimizely.com/flags/v1//projects/{project_id}/groups\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "rpS6bwtHJUuAMPlcTQtoR",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.optimizely.com/flags/v1//projects/{project_id}/groups\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "ZnzwD89tvqq5Bd3sfKtbu",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.optimizely.com/flags/v1//projects/{project_id}/groups\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "icZIBPSIguSE6ulK_JmMl"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// Successful retrieval of a page of Groups.\nThe response includes RESTful JSON (https://restfuljson.org/) styled links and pagination metadata.\nObjects in this API MAY include a url property for a link to itself and MAY append _url to properties for related links.\nIf a link is not present in the response, it indicates a user is not authorized to access the related resource.\n{\n  \"count\": 2,\n  \"create_url\": {},\n  \"filter_url\": {},\n  \"first_url\": {},\n  \"items\": [\n    {\n      \"archive_url\": {},\n      \"archived\": false,\n      \"created_time\": \"2019-05-08T00:00:00.000Z\",\n      \"delete_url\": {},\n      \"description\": \"promotion group\",\n      \"environment_key\": \"production\",\n      \"id\": 1,\n      \"name\": \"PromoGroup\",\n      \"project_id\": \"\",\n      \"revision\": 0,\n      \"role\": \"admin\",\n      \"rules\": {},\n      \"unarchive_url\": {},\n      \"update_url\": {},\n      \"updated_time\": \"2019-05-08T00:00:00.000Z\",\n      \"url\": {},\n      \"urn\": \"groups.flag.optimizely.com::1\"\n    }\n  ],\n  \"last_url\": {},\n  \"next_url\": {},\n  \"page\": 5,\n  \"prev_url\": {},\n  \"reset_url\": {},\n  \"sort_url\": {},\n  \"total_count\": 20,\n  \"total_pages\": 10,\n  \"url\": {}\n}"
        },
        {
          "id": "response-1-400",
          "language": "400",
          "code": "// Malformed requests and invalid parameter names and types\n"
        },
        {
          "id": "response-2-401",
          "language": "401",
          "code": "// Invalid credentials\n"
        },
        {
          "id": "response-3-403",
          "language": "403",
          "code": "// Do not have permission to perform the operation\n"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}